/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/complex.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_complex.h"
#include "pmc_default.h"
#include "complex.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/complex.pmc"
/*
Copyright (C) 2004-2011, Parrot Foundation.

=head1 NAME

src/pmc/complex.pmc - Complex Numbers PMC Class

=head1 DESCRIPTION

C<Complex> provides a representation of complex numbers. It handles
string parsing/generating and basic mathematical operations.

=head2 Functions

Equations used are sometimes listed.  At times, multiple equations are given,
but those starting with => are the ones used

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void complex_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

static void complex_parse_string(PARROT_INTERP,
    ARGOUT(FLOATVAL *re),
    ARGOUT(FLOATVAL *im),
    ARGIN(STRING *value))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        __attribute__nonnull__(4)
        FUNC_MODIFIES(*re)
        FUNC_MODIFIES(*im);

static void float_check_divide_zero(PARROT_INTERP, FLOATVAL value)
        __attribute__nonnull__(1);

static void int_check_divide_zero(PARROT_INTERP, INTVAL value)
        __attribute__nonnull__(1);

#define ASSERT_ARGS_complex_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_complex_parse_string __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(re) \
    , PARROT_ASSERT_ARG(im) \
    , PARROT_ASSERT_ARG(value))
#define ASSERT_ARGS_float_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
#define ASSERT_ARGS_int_check_divide_zero __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void complex_parse_string(PARROT_INTERP, FLOATVAL *re, FLOATVAL
*im, STRING *value)>

Parses the string in C<value> to produce a complex number, represented
by the real (C<*re>) and imaginary (C<*im>) parts. Raises an exception
if it cannot understand the string.  The string should be of the form
C<a+bi> with optional spaces around C<+> and before C<i>. You can also
use C<j> instead of C<i>.

=cut

We have a conflict among our coding standards here.  Our 100-character line
limit meant that the following function declaration had to be split over two
lines.  However, that leads to t/codingstd/pmc_docs.t reporting that this
function lacks documentation -- reporting due to differences in whitespacing
between '=item' and function declaration.

*/

static void
complex_parse_string(PARROT_INTERP,
                     ARGOUT(FLOATVAL *re), ARGOUT(FLOATVAL *im), ARGIN(STRING *value))
{
    ASSERT_ARGS(complex_parse_string)

    char   * const str        = Parrot_str_to_cstring(interp, value);
    char   *t                 = str;
    char   *first_num_offset  = str;
    char   *second_num_offset = NULL;
    STRING *S;

    INTVAL  i                 = 0;
    INTVAL  first_num_minus   = 0;
    INTVAL  second_num_minus  = 0;
    UINTVAL first_num_length, second_num_length;

    /* walk the string and identify the real and imaginary parts */

    if (*t == '-') {
        /* first number is negative */
        ++t;
        first_num_minus = 1;

        /* allow for an optional space */
        if (*t == ' ')
            ++t;
        first_num_offset = t;
    }

    /* skip digits */
    while (*t >= '0' && *t <= '9')
        ++t;

    if (*t == '.') {
        /* this number has a decimal point */
        ++t;

        /* skip digits */
        while (*t >= '0' && *t <= '9')
            ++t;
    }

    /* save the length of the real part */
    first_num_length = t - first_num_offset;

    /* end of string; we only have a real part */
    if (*t == 0) {
        second_num_length = 0;
    }
    else if ((*t == 'i' || *t == 'j') && *(t+1) == 0) {
        /* there is only an imaginary part, so the first number was
            actually the imaginary part */
        second_num_length = first_num_length;
        first_num_length  = 0;
        second_num_offset = first_num_offset;
        second_num_minus  = first_num_minus;
        first_num_minus   = 0;

        /* this is useful if there is no number for
            the imaginary part, like in "-i" */
        i = 1;
    }
    else {
        /* skip an optional space */
        if (*t == ' ')
            ++t;

        /* expect "+" or "-" and the imaginary part */
        if (*t == '+' || *t == '-') {
            /* save the sign */
            second_num_minus = (*t == '-');
            ++t;

            /* skip another optional space */
            if (*t == ' ')
                ++t;

            /* save the beginning of the imaginary part */
            second_num_offset = t;

            /* skip digits */
            while (*t >= '0' && *t <= '9')
                ++t;

            if (*t == '.') {
                /* this number has a decimal point */
                ++t;

                /* skip digits */
                while (*t >= '0' && *t <= '9')
                    ++t;
            }

            /* save the length of the imaginary part */
            second_num_length = t - second_num_offset;

            /* allow for one more optional space */
            if (*t == ' ')
                ++t;

            /* verify that the string ends properly */
            if ((*t != 'i' && *t != 'j') || (*(t+1) != 0)) {
                /* imaginary part does not end in 'i' or 'j' */
                Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_STRING_REPRESENTATION,
                    "Complex: malformed string");
            }

            /* this is useful if there is no number for the
                imaginary part, like in "2+i" */
            i = 1;

            /* all is OK, save the number */
        }
        else {
            /* "+" or "-" not found: error */
            Parrot_str_free_cstring(str);

            Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_STRING_REPRESENTATION,
                "Complex: malformed string");
        }
    }

    /* now we have the offsets and the lengths we turn them into float values */

    if (first_num_length) {
        /* there is a real part, interpret it */
        S   = Parrot_str_new(interp, first_num_offset, first_num_length);
        *re = Parrot_str_to_num(interp, S);
    }
    else {
        /* consider the real part 0.0 */
        *re = 0.0;
    }

    if (second_num_length) {
        /* there is an imaginary part, interpret it */
        S   = Parrot_str_new(interp, second_num_offset, second_num_length);
        *im = Parrot_str_to_num(interp, S);
    }
    else {
        /* consider the imaginary part 0.0 */
        if (i) /* the string was something like "1+i" */
            *im = 1.0;
        else
            *im = 0.0;
    }

    if (first_num_minus)
        *re = -*re;

    if (second_num_minus)
        *im = -*im;

    Parrot_str_free_cstring(str);
}

/*

=item C<static void int_check_divide_zero(PARROT_INTERP, INTVAL value)>

If C<value> is 0, throw a divide by zero exception.

=cut

*/

static void
int_check_divide_zero(PARROT_INTERP, INTVAL value)
{
    ASSERT_ARGS(int_check_divide_zero)

    if (value == 0)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void float_check_divide_zero(PARROT_INTERP, FLOATVAL value)>

If C<value> is 0.0, throw a divide by zero exception.

=cut

*/

static void
float_check_divide_zero(PARROT_INTERP, FLOATVAL value)
{
    ASSERT_ARGS(float_check_divide_zero)

    if (FLOAT_IS_ZERO(value))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}

/*

=item C<static void complex_check_divide_zero(PARROT_INTERP, PMC *value)>

If C<value> is a Complex PMC with a value of 0, throw a divide by zero exception.

=cut

*/

static void
complex_check_divide_zero(PARROT_INTERP, ARGIN(PMC *value))
{
    ASSERT_ARGS(complex_check_divide_zero)

    /* Throw an exception if we are dividing by zero. Check both the real part
     * and the imaginary part.*/

    if (FLOAT_IS_ZERO(VTABLE_get_number_keyed_int(interp, value, 0))
            && FLOAT_IS_ZERO(VTABLE_get_number_keyed_int(interp, value, 1)))
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_DIV_BY_ZERO,
            "Divide by zero");
}
#line 330 "./src/pmc/complex.c"
static  PMC  * Parrot_Complex_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  PMC * Parrot_Complex_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_Complex_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  PMC * Parrot_Complex_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  void  Parrot_Complex_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit);
static  INTVAL  Parrot_Complex_get_bool(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Complex_get_integer(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_Complex_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  INTVAL  Parrot_Complex_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  FLOATVAL  Parrot_Complex_get_number(PARROT_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_Complex_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  FLOATVAL  Parrot_Complex_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  FLOATVAL  Parrot_Complex_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  PMC  * Parrot_Complex_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key);
static  PMC  * Parrot_Complex_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key);
static  PMC  * Parrot_Complex_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key);
static  STRING  * Parrot_Complex_get_string(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Complex_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Complex_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Complex_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_i_neg(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Complex_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *initializer);
static  INTVAL Parrot_Complex_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC * Parrot_Complex_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  PMC  * Parrot_Complex_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest);
static  void  Parrot_Complex_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value);
static  void  Parrot_Complex_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value);
static  void  Parrot_Complex_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL v);
static  void  Parrot_Complex_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value);
static  void  Parrot_Complex_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value);
static  void  Parrot_Complex_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  PMC * Parrot_Complex_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest);
static  PMC  * Parrot_Complex_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest);
static  void  Parrot_Complex_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit);
static  PMC  * Parrot_Complex_multi_add_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_add_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Complex_multi_subtract_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_subtract_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Complex_multi_multiply_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_multiply_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_multi_i_multiply_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  PMC  * Parrot_Complex_multi_divide_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  PMC  * Parrot_Complex_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest);
static  void  Parrot_Complex_multi_i_divide_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Complex_multi_is_equal_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  INTVAL  Parrot_Complex_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void Parrot_Complex_nci_ln(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_exp(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_sin(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_cos(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_tan(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_cot(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_sec(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_csc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_asin(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acos(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_atan(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acot(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acsc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_asec(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_sinh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_cosh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_tanh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_coth(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_csch(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_sech(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_asinh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acosh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_atanh(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acoth(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_acsch(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_asech(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_nci_sqrt(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Complex_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_i_add_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Complex_i_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void Parrot_Complex_i_multiply_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_i_subtract_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Complex_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *initializer);
static  void  Parrot_Complex_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value);
static  void  Parrot_Complex_set_integer_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value);
static  void  Parrot_Complex_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value);
static  void  Parrot_Complex_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL v);
static  void  Parrot_Complex_set_number_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value);
static  void  Parrot_Complex_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value);
static  void  Parrot_Complex_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value);
static  void  Parrot_Complex_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value);
static  void  Parrot_Complex_set_pmc_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value);
static  void  Parrot_Complex_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value);
static  void  Parrot_Complex_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit);
static  void Parrot_Complex_multi_add_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_add_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_subtract_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_subtract_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_multiply_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_multiply_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_divide_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_divide_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_is_equal_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_Complex_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_Complex_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Complex_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Complex_get_vtable(PARROT_INTERP);
void    Parrot_Complex_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Complex_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Complex_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Complex_absolute(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 1255 "./src/pmc/complex.pmc"

    FLOATVAL re, im, d;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    d = sqrt(re*re + im*im);

    dest = Parrot_pmc_new(interp,
        Parrot_hll_get_ctx_HLL_type(interp, enum_class_Float));

    VTABLE_set_number_native(interp, dest, d);
    return dest;
#line 501 "./src/pmc/complex.c"
}
static  PMC *
Parrot_Complex_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_add_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "add", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Complex_multi_add_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Complex_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 762 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re + value);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 541 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 758 "./src/pmc/complex.pmc"

    return VTABLE_add_float(interp, _self, (FLOATVAL)value, dest);
#line 549 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 376 "./src/pmc/complex.pmc"

    PMC * const dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 565 "./src/pmc/complex.c"
}
static  PMC *
Parrot_Complex_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_divide_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "divide", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Complex_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Complex_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 1092 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    float_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / value);
    SETATTR_Complex_im(interp, dest, im / value);

    return dest;
#line 607 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 1078 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    int_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / value);
    SETATTR_Complex_im(interp, dest, im / value);

    return dest;
#line 625 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_freeze(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit)
{
#line 400 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    interp->vtables[enum_class_default]->freeze(interp, _self, visit);

    GETATTR_Complex_re(interp, _self, re);
    VTABLE_push_float(interp, visit, re);

    GETATTR_Complex_im(interp, _self, im);
    VTABLE_push_float(interp, visit, im);
#line 641 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_bool(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 465 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return !(FLOAT_IS_ZERO(re) && FLOAT_IS_ZERO(im));
#line 652 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 446 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, _self);
    return (INTVAL)f;
#line 661 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 492 "./src/pmc/complex.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_integer_keyed_str(interp, _self, s);
#line 670 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_get_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 497 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number_keyed_str(interp, _self, key);
    return (INTVAL)f;
#line 679 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 451 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return sqrt(re * re + im * im);
#line 690 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 502 "./src/pmc/complex.pmc"

    STRING * const s = VTABLE_get_string(interp, key);
    return VTABLE_get_number_keyed_str(interp, _self, s);
#line 699 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 573 "./src/pmc/complex.pmc"

    FLOATVAL f;
    switch (key) {
      case 0:
        GETATTR_Complex_re(interp, _self, f);
        break;
      case 1:
        GETATTR_Complex_im(interp, _self, f);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "Complex: key must be 0 or 1");
    }
    return f;
#line 719 "./src/pmc/complex.c"
}
static  FLOATVAL 
Parrot_Complex_get_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 507 "./src/pmc/complex.pmc"

    FLOATVAL value;
    if (STRING_equal(interp, key, CONST_STRING(interp, "real"))) {
        GETATTR_Complex_re(interp, _self, value);
    }
    else if (STRING_equal(interp, key, CONST_STRING(interp, "imag"))) {
        GETATTR_Complex_im(interp, _self, value);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION, "Complex: key is neither 'real' or 'imag'");
    return value;
#line 737 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key)
{
#line 521 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, key, CONST_STRING(interp, "Integer"))) {
        const INTVAL i = VTABLE_get_integer(interp, key);
        return VTABLE_get_pmc_keyed_int(interp, _self, i);
    }
    else {
        STRING * const s = VTABLE_get_string(interp, key);
        return VTABLE_get_pmc_keyed_str(interp, _self, s);
    }
#line 752 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key)
{
#line 549 "./src/pmc/complex.pmc"

    PMC * const    ret = Parrot_pmc_new(interp, enum_class_Float);
    const FLOATVAL val = VTABLE_get_number_keyed_int(interp, _self, key);
    VTABLE_set_number_native(interp, ret, val);
    return ret;
#line 763 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_get_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key)
{
#line 532 "./src/pmc/complex.pmc"

    PMC * const    ret = Parrot_pmc_new(interp, enum_class_Float);
    const FLOATVAL val = VTABLE_get_number_keyed_str(interp, _self, key);
    VTABLE_set_number_native(interp, ret, val);
    return ret;
#line 774 "./src/pmc/complex.c"
}
static  STRING  *
Parrot_Complex_get_string(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 458 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    return Parrot_sprintf_c(interp, "%vg%+vgi", re, im);
#line 785 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_absolute(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Complex_i_absolute_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Complex_i_add(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Complex_i_add_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_add_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Complex_i_add_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_add_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Complex_i_add_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Complex_i_divide(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Complex_i_divide_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_divide_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Complex_i_divide_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_divide_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Complex_i_divide_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Complex_i_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Complex_i_multiply_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Complex_i_multiply_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Complex_i_multiply_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_neg(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Complex_i_neg_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_Complex_i_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Complex_i_subtract_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Complex_i_subtract_float_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_i_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Complex_i_subtract_int_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Complex_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_init_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *initializer)
{
Parrot_Complex_init_pmc_orig(interp, _self, initializer);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  INTVAL
Parrot_Complex_is_equal(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_is_equal_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            {
                INTVAL retval;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "is_equal", "PP->I", _self, value, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Complex_multi_is_equal_DEFAULT(interp, _self, value);
            break;

    }
}
static  PMC *
Parrot_Complex_multiply(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "multiply", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Complex_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Complex_multiply_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 952 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re * value);
    SETATTR_Complex_im(interp, dest, im * value);

    return dest;
#line 945 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multiply_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 948 "./src/pmc/complex.pmc"

    return VTABLE_multiply_float(interp, _self, (FLOATVAL) value, dest);
#line 953 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_neg(PARROT_INTERP, ARGMOD(PMC *_self), PMC *dest)
{
#line 1180 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, -re);
    SETATTR_Complex_im(interp, dest, -im);

    return dest;
#line 970 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value)
{
Parrot_Complex_set_integer_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_integer_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value)
{
Parrot_Complex_set_integer_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_integer_native(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
Parrot_Complex_set_integer_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_number_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value)
{
Parrot_Complex_set_number_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL v)
{
Parrot_Complex_set_number_keyed_int_orig(interp, _self, key, v);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_number_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value)
{
Parrot_Complex_set_number_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_number_native(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
Parrot_Complex_set_number_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_pmc(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
Parrot_Complex_set_pmc_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_pmc_keyed(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value)
{
Parrot_Complex_set_pmc_keyed_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_pmc_keyed_str(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value)
{
Parrot_Complex_set_pmc_keyed_str_orig(interp, _self, key, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Complex_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
Parrot_Complex_set_string_native_orig(interp, _self, value);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC *
Parrot_Complex_subtract(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            return Parrot_Complex_multi_subtract_Complex_PMC(interp, _self, value, dest);
            break;
        case enum_class_core_max:
            {
                PMC *retval = PMCNULL;
                Parrot_mmd_multi_dispatch_from_c_args(interp, "subtract", "PPP->P", _self, value, dest, &retval);
                return retval;
            }
            break;
        default:
            return Parrot_Complex_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
            break;

    }
}
static  PMC  *
Parrot_Complex_subtract_float(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value, PMC *dest)
{
#line 851 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re - value);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1076 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_subtract_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value, PMC *dest)
{
#line 847 "./src/pmc/complex.pmc"

    return VTABLE_subtract_float(interp, _self, (FLOATVAL)value, dest);
#line 1084 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_thaw(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit)
{
Parrot_Complex_thaw_orig(interp, _self, visit);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  PMC  *
Parrot_Complex_multi_add_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 730 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, dest, self_re + val_re);
    SETATTR_Complex_im(interp, dest, self_im + val_im);

    return dest;
#line 1110 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_add_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 746 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re + VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1126 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_add_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 774 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, _self, self_re + val_re);
    SETATTR_Complex_im(interp, _self, self_im + val_im);
#line 1143 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_add_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 787 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re + VTABLE_get_number(interp, value));
#line 1154 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_subtract_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 819 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, dest, self_re - val_re);
    SETATTR_Complex_im(interp, dest, self_im - val_im);

    return dest;
#line 1174 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_subtract_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 835 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re - VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1190 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_subtract_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 863 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    SETATTR_Complex_re(interp, _self, self_re - val_re);
    SETATTR_Complex_im(interp, _self, self_im - val_im);
#line 1207 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_subtract_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 876 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re - VTABLE_get_number(interp, value));
#line 1218 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_multiply_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 921 "./src/pmc/complex.pmc"

    FLOATVAL a, b, c, d;

    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, a);
    GETATTR_Complex_im(interp, _self, b);
    GETATTR_Complex_re(interp, value, c);
    GETATTR_Complex_im(interp, value, d);
    SETATTR_Complex_re(interp, dest, a * c - b * d);
    SETATTR_Complex_im(interp, dest, a * d + b * c);

    return dest;
#line 1237 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_multiply_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 936 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, dest, re * VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, dest, im * VTABLE_get_number(interp, value));

    return dest;
#line 1253 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_multiply_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 964 "./src/pmc/complex.pmc"

    FLOATVAL a, b, c, d;

    GETATTR_Complex_re(interp, _self, a);
    GETATTR_Complex_im(interp, _self, b);
    GETATTR_Complex_re(interp, value, c);
    GETATTR_Complex_im(interp, value, d);
    SETATTR_Complex_re(interp, _self, a * c - b * d);
    SETATTR_Complex_im(interp, _self, a * d + b * c);
#line 1268 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_multiply_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 975 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * VTABLE_get_number(interp, value));
    SETATTR_Complex_im(interp, _self, im * VTABLE_get_number(interp, value));
#line 1281 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_divide_Complex_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1032 "./src/pmc/complex.pmc"

    FLOATVAL mod, re, im;
    FLOATVAL self_re, self_im, val_re, val_im;

    complex_check_divide_zero(interp, value);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    /* a little speed optimisation: cache an intermediate number;
        I'm not sure the compiler does this */

    if (self_im == 0.0 && val_im == 0.0) {
        re = self_re / val_re;
        im = 0.0;
    }
    else {
        mod = (val_re * val_re + val_im * val_im);
        re  = (self_re * val_re + self_im * val_im) / mod;
        im  = (self_im * val_re - self_re * val_im) / mod;
    }

    SETATTR_Complex_re(interp, dest, re);
    SETATTR_Complex_im(interp, dest, im);

    return dest;
#line 1316 "./src/pmc/complex.c"
}
static  PMC  *
Parrot_Complex_multi_divide_DEFAULT_PMC(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value, PMC *dest)
{
#line 1063 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    const FLOATVAL d = VTABLE_get_number(interp, value);
    float_check_divide_zero(interp, d);
    dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, dest, re / d);
    SETATTR_Complex_im(interp, dest, im / d);

    return dest;
#line 1335 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_divide_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1106 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    FLOATVAL self_re, self_im, val_re, val_im;

    complex_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);

    if (self_im == 0.0 && val_im == 0.0) {
        re = self_re / val_re;
        im = 0.0;
    }
    else {
        /* a little speed optimisation: cache an intermediate number;
           I'm not sure the compiler does this */
        const FLOATVAL mod = (val_re * val_re + val_im * val_im);
        re  = (self_re * val_re + self_im * val_im) / mod;
        im  = (self_im * val_re - self_re * val_im) / mod;
    }

    SETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_im(interp, _self, im);

#line 1367 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_multi_i_divide_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1134 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    const FLOATVAL d = VTABLE_get_number(interp, value);
    float_check_divide_zero(interp, d);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / d);
    SETATTR_Complex_im(interp, _self, im / d);
#line 1383 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_multi_is_equal_Complex(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1211 "./src/pmc/complex.pmc"

    FLOATVAL self_re, self_im, val_re, val_im;
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);
    GETATTR_Complex_re(interp, value, val_re);
    GETATTR_Complex_im(interp, value, val_im);
    return (INTVAL)(self_re == val_re && self_im == val_im);
#line 1396 "./src/pmc/complex.c"
}
static  INTVAL 
Parrot_Complex_multi_is_equal_DEFAULT(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 1220 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (im != 0.0)
        return (INTVAL)0;

    return (re == VTABLE_get_number(interp, value));
#line 1411 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_nci_ln(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1298 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    /* This is necessary for atan2 to behave */
    if (im == -0.0)
        im = 0.0;

    result_re = log(sqrt(re*re + im*im));
    if (re == 0.0 && im == 0.0) /* atan2(0, 0) not portable */
        result_im = 0.0;
    else
        result_im = atan2(im, re);

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 1444 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1317 "./src/pmc/complex.pmc"

#line 1455 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_exp(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1332 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, f;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    f  = exp(re);

    SETATTR_Complex_re(interp, d, f * cos(im));

    /* If only sin(pi) worked. */
    if (im == 4.0 * atan(1.0)) {
        SETATTR_Complex_im(interp, d, 0.0);
    }
    else {
        SETATTR_Complex_im(interp, d, f * sin(im));
    }

    #line 1494 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1350 "./src/pmc/complex.pmc"

#line 1505 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_sin(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1386 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (FLOAT_IS_ZERO(im)) {
        result_re = sin(re);
        result_im = 0.0;
    }
    else if (FLOAT_IS_ZERO(re)) {
        result_re = 0.0;
        result_im = sinh(im);
    }
    else {
        result_re = sin(re) * cosh(im);

        if (im == -0.0)
            result_im = 0.0;
        else
            result_im = cos(re) * sinh(im);

    }

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 1553 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1413 "./src/pmc/complex.pmc"

#line 1564 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_cos(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1416 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, result_re, result_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    if (FLOAT_IS_ZERO(re)) {
        result_re = cosh(im);
        result_im = 0.0;
    }
    else if (FLOAT_IS_ZERO(im)) {
        result_re = cos(re);
        result_im = 0.0;
    }
    else {
        result_re = cos(re) * cosh(im);
        result_im = -1.0 * sin(re) * sinh(im);
    }

    SETATTR_Complex_re(interp, d, result_re);
    SETATTR_Complex_im(interp, d, result_im);

    #line 1607 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1438 "./src/pmc/complex.pmc"

#line 1618 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_tan(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1441 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 1643 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &d);
#line 1445 "./src/pmc/complex.pmc"

    #line 1647 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &e);
#line 1446 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 1654 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1450 "./src/pmc/complex.pmc"

#line 1665 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_cot(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1453 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    #line 1689 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &d);
#line 1456 "./src/pmc/complex.pmc"

    #line 1693 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &e);
#line 1457 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 1700 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1461 "./src/pmc/complex.pmc"

#line 1711 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_sec(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1464 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    SETATTR_Complex_re(interp, d, 1.0);
    SETATTR_Complex_im(interp, d, 0.0);
    #line 1737 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cos"), "->P", &e);
#line 1469 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 1744 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1473 "./src/pmc/complex.pmc"

#line 1755 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_csc(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1476 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    SETATTR_Complex_re(interp, d, 1.0);
    SETATTR_Complex_im(interp, d, 0.0);

    #line 1783 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sin"), "->P", &e);
#line 1483 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 1790 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1487 "./src/pmc/complex.pmc"

#line 1801 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_asin(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1523 "./src/pmc/complex.pmc"

    FLOATVAL d_re, d_im, e_re, e_im, self_re, self_im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *       e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    e      = Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, _self, e);
    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, e, 1.0 - e_re);
    SETATTR_Complex_im(interp, e, -e_im);

    #line 1835 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, e, CONST_STRING_GEN(interp, "sqrt"), "->P", &d);
#line 1536 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, d, d_re - self_im);
    SETATTR_Complex_im(interp, d, d_im + self_re);

    #line 1844 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &d);
#line 1542 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, e, d_im);
    SETATTR_Complex_im(interp, e, d_re ? -d_re : 0.0);

    #line 1853 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1548 "./src/pmc/complex.pmc"

#line 1864 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acos(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1551 "./src/pmc/complex.pmc"

    FLOATVAL d_re, d_im, e_re, e_im, self_re, self_im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *       e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    GETATTR_Complex_re(interp, _self, self_re);
    GETATTR_Complex_im(interp, _self, self_im);

    e = Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, _self, e);
    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, e, 1.0 - e_re);
    SETATTR_Complex_im(interp, e, -e_im);

    #line 1898 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, e, CONST_STRING_GEN(interp, "sqrt"), "->P", &d);
#line 1564 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);
    SETATTR_Complex_re(interp, d, d_re + self_im);
    SETATTR_Complex_im(interp, d, d_im - self_re);

    #line 1907 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &e);
#line 1570 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, e, e_re);
    GETATTR_Complex_im(interp, e, e_im);
    SETATTR_Complex_re(interp, d, e_im + 2.0 * atan(1.0));
    SETATTR_Complex_im(interp, d, e_re ? -e_re : 0.0);

    #line 1916 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1576 "./src/pmc/complex.pmc"

#line 1927 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_atan(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1579 "./src/pmc/complex.pmc"

    PMC * const d  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e  = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im, d_re, d_im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, re);
    SETATTR_Complex_im(interp, d, 1 + im);
    SETATTR_Complex_re(interp, e, -re);
    SETATTR_Complex_im(interp, e, 1 - im);

    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 1962 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "ln"), "->P", &d);
#line 1593 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, d_re);
    GETATTR_Complex_im(interp, d, d_im);

    SETATTR_Complex_re(interp, e, (d_im ? d_im : -0.0) / -2.0);
    SETATTR_Complex_im(interp, e, d_re / 2.0);

    #line 1972 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1600 "./src/pmc/complex.pmc"

#line 1983 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acot(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1603 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2014 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atan"), "->P", &e);
#line 1613 "./src/pmc/complex.pmc"

    #line 2018 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1614 "./src/pmc/complex.pmc"

#line 2029 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acsc(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1617 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2060 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asin"), "->P", &e);
#line 1627 "./src/pmc/complex.pmc"

    #line 2064 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1628 "./src/pmc/complex.pmc"

#line 2075 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_asec(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1631 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2106 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "acos"), "->P", &e);
#line 1641 "./src/pmc/complex.pmc"

    #line 2110 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1642 "./src/pmc/complex.pmc"

#line 2121 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_sinh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1665 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, sinh(re) * cos(im));
    SETATTR_Complex_im(interp, d, im ? cosh(re) * sin(im) : 0.0);

    #line 2151 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1674 "./src/pmc/complex.pmc"

#line 2162 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_cosh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1677 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d, cosh(re) * cos(im));
    if (re == 0.0 || im == 0.0) {
        SETATTR_Complex_im(interp, d, 0.0);
    }
    else {
        SETATTR_Complex_im(interp, d, sinh(re) * sin(im));
    }

    #line 2197 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1691 "./src/pmc/complex.pmc"

#line 2208 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_tanh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1694 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2233 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sinh"), "->P", &d);
#line 1698 "./src/pmc/complex.pmc"

    #line 2237 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cosh"), "->P", &e);
#line 1699 "./src/pmc/complex.pmc"


    Parrot_Complex_multi_i_divide_Complex(interp, d, e);

    #line 2244 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1703 "./src/pmc/complex.pmc"

#line 2255 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_coth(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1706 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2280 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "tanh"), "->P", &d);
#line 1710 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 2290 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1717 "./src/pmc/complex.pmc"

#line 2301 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_csch(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1720 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2326 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "sinh"), "->P", &d);
#line 1724 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 2336 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1731 "./src/pmc/complex.pmc"

#line 2347 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_sech(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1734 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2372 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "cosh"), "->P", &d);
#line 1738 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);

    SETATTR_Complex_re(interp, d, re ?  re / (re * re + im * im) : 0.0);
    SETATTR_Complex_im(interp, d, im ? -im / (re * re + im * im) : 0.0);

    #line 2382 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *d */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)d);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *d */
    }
#line 1745 "./src/pmc/complex.pmc"

#line 2393 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_asinh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1776 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, d,  im);
    SETATTR_Complex_im(interp, d, -re);

    #line 2424 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asin"), "->P", &d);
#line 1786 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 2433 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1792 "./src/pmc/complex.pmc"

#line 2444 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acosh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1795 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    #line 2470 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING_GEN(interp, "acos"), "->P", &d);
#line 1800 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 2479 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1806 "./src/pmc/complex.pmc"

#line 2490 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_atanh(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1809 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC * const e = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, d,  im);
    SETATTR_Complex_im(interp, d, -re);

    #line 2521 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atan"), "->P", &d);
#line 1819 "./src/pmc/complex.pmc"

    GETATTR_Complex_re(interp, d, re);
    GETATTR_Complex_im(interp, d, im);
    SETATTR_Complex_re(interp, e, -im);
    SETATTR_Complex_im(interp, e,  re);

    #line 2530 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1825 "./src/pmc/complex.pmc"

#line 2541 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acoth(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1828 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2572 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "atanh"), "->P", &e);
#line 1838 "./src/pmc/complex.pmc"

    #line 2576 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1839 "./src/pmc/complex.pmc"

#line 2587 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_acsch(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1842 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2618 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "asinh"), "->P", &e);
#line 1852 "./src/pmc/complex.pmc"

    #line 2622 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1853 "./src/pmc/complex.pmc"

#line 2633 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_asech(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1856 "./src/pmc/complex.pmc"

    PMC * const d = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC     *e;
    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, d,  re / (re * re + im * im));
    SETATTR_Complex_im(interp, d, -im / (re * re + im * im));

    #line 2664 "./src/pmc/complex.pmc"
Parrot_pcc_invoke_method_from_c_args(interp, d, CONST_STRING_GEN(interp, "acosh"), "->P", &e);
#line 1866 "./src/pmc/complex.pmc"

    #line 2668 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *e */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)e);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *e */
    }
#line 1867 "./src/pmc/complex.pmc"

#line 2679 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_pow(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
PMC* value;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiP",
            &_self, &value);
    { /* BEGIN PMETHOD BODY */
#line 1892 "./src/pmc/complex.pmc"

    PMC *l = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    PMC *log;
    PMC * const dest = Parrot_pmc_new(interp, VTABLE_type(interp, _self));

    Parrot_pcc_invoke_method_from_c_args(interp, _self, CONST_STRING(interp, "ln"),
                "->P", &log);

    l = VTABLE_multiply(interp, log, value, l);

    Parrot_pcc_invoke_method_from_c_args(interp, l, CONST_STRING(interp, "exp"),
                "->P", &dest);
    #line 2713 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *dest */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)dest);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *dest */
    }
#line 1904 "./src/pmc/complex.pmc"

#line 2724 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_Complex_nci_sqrt(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 1907 "./src/pmc/complex.pmc"

    PMC * const result = Parrot_pmc_new(interp, VTABLE_type(interp, _self));
    const FLOATVAL absval = _self->vtable->get_number(interp, _self);
    FLOATVAL sx, sy, rx, ry;
    GETATTR_Complex_re(interp, _self, sx);
    GETATTR_Complex_im(interp, _self, sy);

    rx = sqrt((absval + sx) / 2);
    ry = sqrt((absval - sx) / 2);
    if (sy < 0)
        ry = -ry;
    SETATTR_Complex_re(interp, result, rx);
    SETATTR_Complex_im(interp, result, ry);
    #line 2758 "./src/pmc/complex.c"
    {
    /*BEGIN RETURN PMC *result */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)result);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *result */
    }
#line 1920 "./src/pmc/complex.pmc"

#line 2769 "./src/pmc/complex.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_Complex_i_absolute_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1268 "./src/pmc/complex.pmc"

    FLOATVAL re, im, d;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    d = sqrt(re*re + im*im);
    Parrot_pmc_reuse(interp, _self, enum_class_Float, 0);
    VTABLE_set_number_native(interp, _self, d);
#line 2789 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_add_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_add_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_add", "PP->", _self, value);
            break;
        default:
            Parrot_Complex_multi_i_add_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Complex_i_add_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 798 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re + value);
#line 2820 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_add_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 794 "./src/pmc/complex.pmc"

    VTABLE_i_add_float(interp, _self, (FLOATVAL)value);
#line 2828 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_divide_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_divide_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_divide", "PP->", _self, value);
            break;
        default:
            Parrot_Complex_multi_i_divide_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Complex_i_divide_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 1157 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    float_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / value);
    SETATTR_Complex_im(interp, _self, im / value);
#line 2863 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_divide_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 1146 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    int_check_divide_zero(interp, value);

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);

    SETATTR_Complex_re(interp, _self, re / value);
    SETATTR_Complex_im(interp, _self, im / value);
#line 2878 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_multiply_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_multiply_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_multiply", "PP->", _self, value);
            break;
        default:
            Parrot_Complex_multi_i_multiply_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Complex_i_multiply_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 993 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * value);
    SETATTR_Complex_im(interp, _self, im * value);
#line 2911 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_multiply_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 984 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, re * value);
    SETATTR_Complex_im(interp, _self, im * value);
#line 2924 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_neg_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 1193 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    GETATTR_Complex_re(interp, _self, re);
    GETATTR_Complex_im(interp, _self, im);
    SETATTR_Complex_re(interp, _self, -re);
    SETATTR_Complex_im(interp, _self, -im);
#line 2936 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_i_subtract_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
    INTVAL type = VTABLE_type(interp, value);
    /* For dynpmc fallback to MMD */
    if ((type >= enum_class_core_max) || (VTABLE_type(interp, _self) >= enum_class_core_max))
        type = enum_class_core_max;
    switch(type) {
        case enum_class_Complex:
            Parrot_Complex_multi_i_subtract_Complex(interp, _self, value);
            break;
        case enum_class_core_max:
            Parrot_mmd_multi_dispatch_from_c_args(interp, "i_subtract", "PP->", _self, value);
            break;
        default:
            Parrot_Complex_multi_i_subtract_DEFAULT(interp, _self, value);
            break;

    }
}
static  void 
Parrot_Complex_i_subtract_float_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 887 "./src/pmc/complex.pmc"

    FLOATVAL re;

    GETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_re(interp, _self, re - value);
#line 2967 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_i_subtract_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 883 "./src/pmc/complex.pmc"

    VTABLE_i_subtract_float(interp, _self, (FLOATVAL) value);
#line 2975 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 339 "./src/pmc/complex.pmc"

    SETATTR_Complex_re(interp, _self, 0.0);
    SETATTR_Complex_im(interp, _self, 0.0);
#line 2984 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_init_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *initializer)
{
#line 344 "./src/pmc/complex.pmc"

    const INTVAL arg_type = VTABLE_type(interp, initializer);
    VTABLE_init(interp, _self);
    switch (arg_type) {
      case enum_class_String:
        VTABLE_set_string_native(interp, _self, VTABLE_get_string(interp, initializer));
        break;
      case enum_class_FixedFloatArray:
      case enum_class_ResizableFloatArray:
      case enum_class_FixedIntegerArray:
      case enum_class_ResizableIntegerArray:
        if (VTABLE_get_integer(interp, initializer) == 2) {
            const FLOATVAL re = VTABLE_get_number_keyed_int(interp, initializer, 0);
            const FLOATVAL im = VTABLE_get_number_keyed_int(interp, initializer, 1);
            SETATTR_Complex_re(interp, _self, re);
            SETATTR_Complex_im(interp, _self, im);
            break;
        }
        /* else let it fall to default */
      default:
        if (VTABLE_isa(interp, initializer, CONST_STRING(interp, "String"))) {
            STRING * const s = VTABLE_get_string(interp, initializer);
            VTABLE_set_string_native(interp, _self, s);
        }
        else {
            Parrot_ex_throw_from_c_args(interp, NULL,
                    EXCEPTION_INVALID_OPERATION,
                    "Invalid Complex initializer");
        }
    }
#line 3020 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, INTVAL value)
{
#line 675 "./src/pmc/complex.pmc"

    VTABLE_set_number_keyed(interp, _self, key, (FLOATVAL)value);
#line 3028 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, INTVAL value)
{
#line 679 "./src/pmc/complex.pmc"

    VTABLE_set_number_keyed_str(interp, _self, key, (FLOATVAL)value);
#line 3036 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_integer_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL value)
{
#line 645 "./src/pmc/complex.pmc"

    VTABLE_set_number_native(interp, _self, (FLOATVAL)value);
#line 3044 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, FLOATVAL value)
{
#line 683 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, key, CONST_STRING(interp, "Integer"))) {
        const INTVAL i = VTABLE_get_integer(interp, key);
        VTABLE_set_number_keyed_int(interp, _self, i, value);
    }
    else {
        STRING *s = VTABLE_get_string(interp, key);
        VTABLE_set_number_keyed_str(interp, _self, s, value);
    }
#line 3059 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed_int_orig(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL key, FLOATVAL v)
{
#line 589 "./src/pmc/complex.pmc"

    switch (key) {
      case 0:
        SETATTR_Complex_re(interp, _self, v);
        break;
      case 1:
        SETATTR_Complex_im(interp, _self, v);
        break;
      default:
        Parrot_ex_throw_from_c_args(interp, NULL,
                EXCEPTION_INVALID_OPERATION, "Complex: key must be 0 or 1");
    }
#line 3077 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, FLOATVAL value)
{
#line 694 "./src/pmc/complex.pmc"

    if (STRING_equal(interp, key, CONST_STRING(interp, "real"))) {
        SETATTR_Complex_re(interp, _self, value);
    }
    else if (STRING_equal(interp, key, CONST_STRING(interp, "imag"))) {
        SETATTR_Complex_im(interp, _self, value);
    }
    else
        Parrot_ex_throw_from_c_args(interp, NULL,
            EXCEPTION_INVALID_OPERATION, "Complex: key is neither 'real' or 'imag'");
#line 3093 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_number_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), FLOATVAL value)
{
#line 649 "./src/pmc/complex.pmc"

    SETATTR_Complex_re(interp, _self, value);
    SETATTR_Complex_im(interp, _self, 0.0);
#line 3102 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *value)
{
#line 633 "./src/pmc/complex.pmc"

    if (VTABLE_isa(interp, value, CONST_STRING(interp, "Complex"))) {
        FLOATVAL re, im;
        GETATTR_Complex_re(interp, value, re);
        GETATTR_Complex_im(interp, value, im);
        SETATTR_Complex_re(interp, _self, re);
        SETATTR_Complex_im(interp, _self, im);
    }
    else
        VTABLE_set_string_native(interp, _self, VTABLE_get_string(interp, value));
#line 3118 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc_keyed_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *key, PMC *value)
{
#line 706 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, value);
    VTABLE_set_number_keyed(interp, _self, key, f);
#line 3127 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_pmc_keyed_str_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *key, PMC *value)
{
#line 711 "./src/pmc/complex.pmc"

    const FLOATVAL f = VTABLE_get_number(interp, value);
    VTABLE_set_number_keyed_str(interp, _self, key, f);
#line 3136 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_set_string_native_orig(PARROT_INTERP, ARGMOD(PMC *_self), STRING *value)
{
#line 626 "./src/pmc/complex.pmc"

    FLOATVAL re, im;
    complex_parse_string(interp, &re, &im, value);
    SETATTR_Complex_re(interp, _self, re);
    SETATTR_Complex_im(interp, _self, im);
#line 3147 "./src/pmc/complex.c"
}
static  void 
Parrot_Complex_thaw_orig(PARROT_INTERP, ARGMOD(PMC *_self), PMC *visit)
{
#line 412 "./src/pmc/complex.pmc"

    FLOATVAL re, im;

    interp->vtables[enum_class_default]->thaw(interp, _self, visit);

    re = VTABLE_shift_float(interp, visit);
    SETATTR_Complex_re(interp, _self, re);

    im = VTABLE_shift_float(interp, visit);
    SETATTR_Complex_im(interp, _self, im);
#line 3163 "./src/pmc/complex.c"
}
static  void
Parrot_Complex_multi_add_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_add_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_add_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_add_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_i_add_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_add_Complex(interp, _self, value);
}
static  void
Parrot_Complex_multi_i_add_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_add_DEFAULT(interp, _self, value);
}
static  void
Parrot_Complex_multi_subtract_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_subtract_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_subtract_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_subtract_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_i_subtract_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_subtract_Complex(interp, _self, value);
}
static  void
Parrot_Complex_multi_i_subtract_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_subtract_DEFAULT(interp, _self, value);
}
static  void
Parrot_Complex_multi_multiply_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_multiply_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_multiply_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_multiply_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_i_multiply_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_multiply_Complex(interp, _self, value);
}
static  void
Parrot_Complex_multi_i_multiply_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_multiply_DEFAULT(interp, _self, value);
}
static  void
Parrot_Complex_multi_divide_Complex_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_divide_Complex_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_divide_DEFAULT_PMC_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value; PMC *dest;
PMC * _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiPP", &_self, &value, &dest);
_result = Parrot_Complex_multi_divide_DEFAULT_PMC(interp, _self, value, dest);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "P", _result);
}
static  void
Parrot_Complex_multi_i_divide_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_divide_Complex(interp, _self, value);
}
static  void
Parrot_Complex_multi_i_divide_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
Parrot_Complex_multi_i_divide_DEFAULT(interp, _self, value);
}
static  void
Parrot_Complex_multi_is_equal_Complex_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Complex_multi_is_equal_Complex(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
static  void
Parrot_Complex_multi_is_equal_DEFAULT_pcc(PARROT_INTERP, ARGMOD(PMC *_self))
{
PMC *value;
INTVAL  _result;
PMC *_call_obj = Parrot_pcc_get_signature(interp, CURRENT_CONTEXT(interp));
Parrot_pcc_fill_params_from_c_args(interp, _call_obj, "PiP", &_self, &value);
_result = Parrot_Complex_multi_is_equal_DEFAULT(interp, _self, value);
    Parrot_pcc_set_call_from_c_args(interp, _call_obj, "I", _result);
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Complex_update_vtable(VTABLE *vt) {
    vt->absolute = Parrot_Complex_absolute;
    vt->add = Parrot_Complex_add;
    vt->add_float = Parrot_Complex_add_float;
    vt->add_int = Parrot_Complex_add_int;
    vt->clone = Parrot_Complex_clone;
    vt->divide = Parrot_Complex_divide;
    vt->divide_float = Parrot_Complex_divide_float;
    vt->divide_int = Parrot_Complex_divide_int;
    vt->freeze = Parrot_Complex_freeze;
    vt->get_bool = Parrot_Complex_get_bool;
    vt->get_integer = Parrot_Complex_get_integer;
    vt->get_integer_keyed = Parrot_Complex_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Complex_get_integer_keyed_str;
    vt->get_number = Parrot_Complex_get_number;
    vt->get_number_keyed = Parrot_Complex_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Complex_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Complex_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Complex_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Complex_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Complex_get_pmc_keyed_str;
    vt->get_string = Parrot_Complex_get_string;
    vt->i_absolute = Parrot_Complex_i_absolute;
    vt->i_add = Parrot_Complex_i_add;
    vt->i_add_float = Parrot_Complex_i_add_float;
    vt->i_add_int = Parrot_Complex_i_add_int;
    vt->i_divide = Parrot_Complex_i_divide;
    vt->i_divide_float = Parrot_Complex_i_divide_float;
    vt->i_divide_int = Parrot_Complex_i_divide_int;
    vt->i_multiply = Parrot_Complex_i_multiply;
    vt->i_multiply_float = Parrot_Complex_i_multiply_float;
    vt->i_multiply_int = Parrot_Complex_i_multiply_int;
    vt->i_neg = Parrot_Complex_i_neg;
    vt->i_subtract = Parrot_Complex_i_subtract;
    vt->i_subtract_float = Parrot_Complex_i_subtract_float;
    vt->i_subtract_int = Parrot_Complex_i_subtract_int;
    vt->init = Parrot_Complex_init;
    vt->init_pmc = Parrot_Complex_init_pmc;
    vt->is_equal = Parrot_Complex_is_equal;
    vt->multiply = Parrot_Complex_multiply;
    vt->multiply_float = Parrot_Complex_multiply_float;
    vt->multiply_int = Parrot_Complex_multiply_int;
    vt->neg = Parrot_Complex_neg;
    vt->set_integer_keyed = Parrot_Complex_set_integer_keyed;
    vt->set_integer_keyed_str = Parrot_Complex_set_integer_keyed_str;
    vt->set_integer_native = Parrot_Complex_set_integer_native;
    vt->set_number_keyed = Parrot_Complex_set_number_keyed;
    vt->set_number_keyed_int = Parrot_Complex_set_number_keyed_int;
    vt->set_number_keyed_str = Parrot_Complex_set_number_keyed_str;
    vt->set_number_native = Parrot_Complex_set_number_native;
    vt->set_pmc = Parrot_Complex_set_pmc;
    vt->set_pmc_keyed = Parrot_Complex_set_pmc_keyed;
    vt->set_pmc_keyed_str = Parrot_Complex_set_pmc_keyed_str;
    vt->set_string_native = Parrot_Complex_set_string_native;
    vt->subtract = Parrot_Complex_subtract;
    vt->subtract_float = Parrot_Complex_subtract_float;
    vt->subtract_int = Parrot_Complex_subtract_int;
    vt->thaw = Parrot_Complex_thaw;
    vt->attr_size = sizeof(Parrot_Complex_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Complex_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->absolute = Parrot_Complex_absolute;
    vt->add = Parrot_Complex_add;
    vt->add_float = Parrot_Complex_add_float;
    vt->add_int = Parrot_Complex_add_int;
    vt->clone = Parrot_Complex_clone;
    vt->divide = Parrot_Complex_divide;
    vt->divide_float = Parrot_Complex_divide_float;
    vt->divide_int = Parrot_Complex_divide_int;
    vt->freeze = Parrot_Complex_freeze;
    vt->get_bool = Parrot_Complex_get_bool;
    vt->get_integer = Parrot_Complex_get_integer;
    vt->get_integer_keyed = Parrot_Complex_get_integer_keyed;
    vt->get_integer_keyed_str = Parrot_Complex_get_integer_keyed_str;
    vt->get_number = Parrot_Complex_get_number;
    vt->get_number_keyed = Parrot_Complex_get_number_keyed;
    vt->get_number_keyed_int = Parrot_Complex_get_number_keyed_int;
    vt->get_number_keyed_str = Parrot_Complex_get_number_keyed_str;
    vt->get_pmc_keyed = Parrot_Complex_get_pmc_keyed;
    vt->get_pmc_keyed_int = Parrot_Complex_get_pmc_keyed_int;
    vt->get_pmc_keyed_str = Parrot_Complex_get_pmc_keyed_str;
    vt->get_string = Parrot_Complex_get_string;
    vt->is_equal = Parrot_Complex_is_equal;
    vt->multiply = Parrot_Complex_multiply;
    vt->multiply_float = Parrot_Complex_multiply_float;
    vt->multiply_int = Parrot_Complex_multiply_int;
    vt->neg = Parrot_Complex_neg;
    vt->subtract = Parrot_Complex_subtract;
    vt->subtract_float = Parrot_Complex_subtract_float;
    vt->subtract_int = Parrot_Complex_subtract_int;
    vt->attr_size = sizeof(Parrot_Complex_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Complex_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_Complex_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Complex_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_Complex_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Complex_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Complex"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Complex_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Complex")), PMCNULL);
    return isa;
}

void
Parrot_Complex_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        "Fre Fim ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Complex_get_vtable(interp);
        vt->base_type      = enum_class_Complex;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Complex");
        vt->provides_str = CONST_STRING_GEN(interp, "complex scalar");
        vt->isa_hash     = Parrot_Complex_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Complex_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Complex;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Complex_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "ln");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_ln),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "exp");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_exp),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sin");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sin),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "cos");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cos),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "tan");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_tan),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "cot");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cot),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sec");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sec),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "csc");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_csc),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "asin");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asin),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acos");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acos),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "atan");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_atan),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acot");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acot),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acsc");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acsc),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "asec");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asec),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sinh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sinh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "cosh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_cosh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "tanh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_tanh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "coth");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_coth),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "csch");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_csch),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sech");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sech),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "asinh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asinh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acosh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acosh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "atanh");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_atanh),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acoth");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acoth),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "acsch");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_acsch),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "asech");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_asech),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "pow");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_pow),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "sqrt");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_Complex_nci_sqrt),
                method_name, signature);
        }
        {
            STRING * const mfl_0 = CONST_STRING_GEN(interp, "add");
            STRING * const mfl_1 = CONST_STRING_GEN(interp, "Complex,Complex,PMC");
            STRING * const mfl_2 = CONST_STRING_GEN(interp, "Complex");
            STRING * const mfl_3 = CONST_STRING_GEN(interp, "Complex,DEFAULT,PMC");
            STRING * const mfl_4 = CONST_STRING_GEN(interp, "i_add");
            STRING * const mfl_5 = CONST_STRING_GEN(interp, "Complex,Complex");
            STRING * const mfl_6 = CONST_STRING_GEN(interp, "Complex,DEFAULT");
            STRING * const mfl_7 = CONST_STRING_GEN(interp, "subtract");
            STRING * const mfl_8 = CONST_STRING_GEN(interp, "i_subtract");
            STRING * const mfl_9 = CONST_STRING_GEN(interp, "multiply");
            STRING * const mfl_10 = CONST_STRING_GEN(interp, "i_multiply");
            STRING * const mfl_11 = CONST_STRING_GEN(interp, "divide");
            STRING * const mfl_12 = CONST_STRING_GEN(interp, "i_divide");
            STRING * const mfl_13 = CONST_STRING_GEN(interp, "is_equal");
        PMC *_temp_func;
_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_add_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_add_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_0, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_add_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_4, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_add_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_4, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_subtract_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_7, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_subtract_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_7, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_subtract_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_8, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_subtract_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_8, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_multiply_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_9, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_multiply_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_9, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_multiply_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_multiply_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_10, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_divide_Complex_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_1, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_divide_DEFAULT_PMC_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_11, mfl_3, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_divide_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_i_divide_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_12, mfl_6, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_is_equal_Complex_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_5, _temp_func);

_temp_func = Parrot_pmc_new(interp, enum_class_NativePCCMethod);
VTABLE_set_pointer_keyed_str(interp, _temp_func, CONST_STRING(interp, "->"), (void *)Parrot_Complex_multi_is_equal_DEFAULT_pcc);
Parrot_mmd_add_multi_from_long_sig(interp, mfl_13, mfl_6, _temp_func);

        }
    } /* pass */
} /* Parrot_Complex_class_init */

#line 1922 "./src/pmc/complex.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
