/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/coroutine.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_coroutine.h"
#include "pmc_sub.h"
#include "pmc_default.h"
#include "coroutine.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/coroutine.pmc"
/*
Copyright (C) 2001-2012, Parrot Foundation.

=head1 NAME

src/pmc/coroutine.pmc - Co-Routine PMC

=head1 DESCRIPTION

C<Coroutine> extends C<Sub> to provide a subroutine that can
stop in the middle, and start back up later at the point at which it
stopped. See the L<Glossary|docs/glossary.pod> for more information.

=head2 Flags

=over 4

=item private0 call flip flop

=item private3 restore current sub after "flop".  Used by generators.

=back

=head2 Methods

=over 4

=cut

*/

#include "parrot/oplib/ops.h"

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void print_sub_name(PARROT_INTERP, ARGIN(PMC *sub_pmc))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_print_sub_name __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(sub_pmc))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static void print_sub_name(PARROT_INTERP, PMC *sub_pmc)>

static function to print coroutine information (for tracing/debugging)

=cut

*/

static void
print_sub_name(PARROT_INTERP, ARGIN(PMC *sub_pmc))
{
    /* It's actually a Parrot_coroutine, but this avoids casting warnings. */
    PMC           *ctx;
    Interp * const tracer = (interp->pdb && interp->pdb->debugger) ?
            interp->pdb->debugger :
            interp;

    GETATTR_Coroutine_ctx(interp, sub_pmc, ctx);

    Parrot_io_eprintf(tracer, "# %s coroutine '%Ss'",
        !(PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF) ?
        "Calling" : "yielding from",
        Parrot_sub_full_sub_name(interp, sub_pmc));

    if (!PMC_IS_NULL(ctx) && (PObj_get_FLAGS(sub_pmc) & SUB_FLAG_CORO_FF)) {
        Parrot_io_eprintf(tracer, " to '%Ss'",
                Parrot_sub_full_sub_name(interp,
                    Parrot_pcc_get_sub(interp, Parrot_pcc_get_caller_ctx(interp, ctx))));
    }

    Parrot_io_eprintf(tracer, "\n# ");
    print_pbc_location(interp);
}
#line 106 "./src/pmc/coroutine.c"
static  PMC  * Parrot_Coroutine_clone(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Coroutine_increment(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Coroutine_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  opcode_t  * Parrot_Coroutine_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next);
static  void  Parrot_Coroutine_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_Coroutine_init_orig(PARROT_INTERP, ARGMOD(PMC *_self));
void    Parrot_Coroutine_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Coroutine_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Coroutine_get_vtable(PARROT_INTERP);
void    Parrot_Coroutine_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_Coroutine_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_Coroutine_ro_get_vtable(PARROT_INTERP);
static  PMC  *
Parrot_Coroutine_clone(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 121 "./src/pmc/coroutine.pmc"

    PMC * const ret = Parrot_pmc_new(interp, _self->vtable->base_type);

    PObj_custom_mark_destroy_SETALL(ret);

    memcpy((Parrot_Coroutine_attributes *)PMC_data(ret),
            (Parrot_Coroutine_attributes *)PMC_data(_self),
            sizeof (Parrot_Coroutine_attributes));

    return ret;
#line 133 "./src/pmc/coroutine.c"
}
static  void 
Parrot_Coroutine_increment(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Coroutine_increment_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_Coroutine_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_Coroutine_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  opcode_t  *
Parrot_Coroutine_invoke(PARROT_INTERP, ARGMOD(PMC *_self), void *next)
{
#line 157 "./src/pmc/coroutine.pmc"

    PMC               *ctx;
    opcode_t          *dest;
    PackFile_ByteCode *wanted_seg;
    PMC      * const signature = Parrot_pcc_get_signature(interp,
                                        CURRENT_CONTEXT(interp));

    if (Interp_trace_TEST(interp, PARROT_TRACE_SUB_CALL_FLAG))
        print_sub_name(interp, _self);

    GETATTR_Coroutine_ctx(interp, _self, ctx);

    if (PMC_IS_NULL(ctx)) {
        PackFile_ByteCode *seg;
        size_t             start_offs;
        const UINTVAL     *n_regs_used;
        PMC               *lex_info;
        PMC * const        caller_ctx = CURRENT_CONTEXT(interp);
        PMC               *ccont      = interp->current_cont;

        PARROT_ASSERT(!PMC_IS_NULL(ccont));

        ctx        = Parrot_pcc_get_signature(interp, caller_ctx);
        if (PObj_get_FLAGS(ccont) & SUB_FLAG_TAILCALL)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                    "tail call to coroutine not allowed");

        /* first time set current sub, cont, object */
        if (PMC_IS_NULL(ctx))
            ctx = Parrot_pmc_new(interp, enum_class_CallContext);

        Parrot_pcc_set_context(interp, ctx);

        GETATTR_Coroutine_n_regs_used(interp, _self, n_regs_used);
        Parrot_pcc_allocate_registers(interp, ctx, n_regs_used);
        Parrot_pcc_set_caller_ctx(interp, ctx, caller_ctx);
        Parrot_pcc_init_context(interp, ctx, caller_ctx);

        SETATTR_Coroutine_ctx(interp, _self, ctx);

        SETATTR_Continuation_from_ctx(interp, ccont, ctx);

        Parrot_pcc_set_sub(interp, ctx, _self);
        Parrot_pcc_set_continuation(interp, ctx, ccont);

        interp->current_cont   = PMCNULL;

        GETATTR_Coroutine_lex_info(interp, _self, lex_info);

        /* create pad if needed */
        if (!PMC_IS_NULL(lex_info)) {
            const INTVAL hlltype = Parrot_hll_get_ctx_HLL_type(interp, enum_class_LexPad);
            PMC * const lexpad = Parrot_pmc_new_init(interp, hlltype, lex_info);
            Parrot_pcc_set_lex_pad(interp, ctx, lexpad);
            VTABLE_set_pointer(interp, lexpad, ctx);
        }

        GETATTR_Coroutine_seg(interp, _self, seg);
        PObj_get_FLAGS(_self) |= SUB_FLAG_CORO_FF;
        wanted_seg            = seg;

        GETATTR_Coroutine_start_offs(interp, _self, start_offs);
        SETATTR_Coroutine_caller_seg(interp, _self, interp->code);
        SETATTR_Coroutine_address(interp, _self, seg->base.data + start_offs);
    }

    /* if calling the Coro we need the segment of the Coro */
    else if (!(PObj_get_FLAGS(_self) & SUB_FLAG_CORO_FF)) {
        PackFile_ByteCode *seg;
        PMC               *ccont;

        GETATTR_Coroutine_ctx(interp, _self, ctx);
        ccont = Parrot_pcc_get_continuation(interp, ctx);

        PObj_get_FLAGS(_self) |= SUB_FLAG_CORO_FF;

        GETATTR_Coroutine_seg(interp, _self, seg);
        wanted_seg            = seg;

        /* remember segment of caller */
        SETATTR_Coroutine_caller_seg(interp, _self, interp->code);



        /* and the recent call context */
        SETATTR_Continuation_to_ctx(interp, ccont, CURRENT_CONTEXT(interp));
        Parrot_pcc_set_caller_ctx(interp, ctx, CURRENT_CONTEXT(interp));

        /* set context to coroutine context */
        Parrot_pcc_set_context(interp, ctx);
    }
    else {
        INTVAL             yield;
        PMC               *ccont, *to_ctx;
        PackFile_ByteCode *caller_seg;

        GETATTR_Coroutine_yield(interp, _self, yield);

        if (!yield)
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                           "Cannot resume dead coroutine.");

        SETATTR_Coroutine_yield(interp, _self, 0);

        GETATTR_Coroutine_ctx(interp, _self, ctx);
        ccont = Parrot_pcc_get_continuation(interp, ctx);

        GETATTR_Continuation_to_ctx(interp, ccont, to_ctx);

        PObj_get_FLAGS(_self) &= ~SUB_FLAG_CORO_FF;
        GETATTR_Coroutine_caller_seg(interp, _self, caller_seg);

        /* switch back to last remembered code seg and context */
        wanted_seg = caller_seg;

        if (PMC_IS_NULL(to_ctx)) {
            /* This still isn't quite right, but it beats segfaulting.  See
               the "Call an exited coroutine" case in t/pmc/coroutine.t; the
               problem is that the defunct coroutine yields up one more
               result before we get here.  -- rgr, 7-Oct-06.
             * This may be unneeded after the yield fix, see TT #1003
             */
            Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
                           "Cannot resume dead coroutine.");
        }

        Parrot_pcc_set_context(interp, to_ctx);
    }

    Parrot_pcc_set_signature(interp, CURRENT_CONTEXT(interp), signature);

    /* toggle address */
    GETATTR_Coroutine_address(interp, _self, dest);
    SETATTR_Coroutine_address(interp, _self, (opcode_t *)next);

    if (interp->code != wanted_seg)
        Parrot_switch_to_cs(interp, wanted_seg, 1);

    return dest;
#line 290 "./src/pmc/coroutine.c"
}
static  void 
Parrot_Coroutine_increment_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 143 "./src/pmc/coroutine.pmc"

    SETATTR_Coroutine_yield(interp, _self, 1);
#line 298 "./src/pmc/coroutine.c"
}
static  void 
Parrot_Coroutine_init_orig(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 103 "./src/pmc/coroutine.pmc"

    SETATTR_Coroutine_seg(interp, _self, interp->code);
    SETATTR_Coroutine_ctx(interp, _self, PMCNULL);

    PObj_custom_mark_destroy_SETALL(_self);
#line 309 "./src/pmc/coroutine.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_Coroutine_update_vtable(VTABLE *vt) {
    vt->clone = Parrot_Coroutine_clone;
    vt->increment = Parrot_Coroutine_increment;
    vt->init = Parrot_Coroutine_init;
    vt->invoke = Parrot_Coroutine_invoke;
    vt->attr_size = sizeof(Parrot_Coroutine_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_Coroutine_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->clone = Parrot_Coroutine_clone;
    vt->invoke = Parrot_Coroutine_invoke;
    vt->attr_size = sizeof(Parrot_Coroutine_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Coroutine_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_get_vtable(interp);
    Parrot_Coroutine_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_Coroutine_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_Sub_ro_get_vtable(interp);
    Parrot_Coroutine_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_Coroutine_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }
    mro = Parrot_Sub_get_mro(interp, mro);

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "Coroutine"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_Coroutine_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    isa = Parrot_Sub_get_isa(interp, isa);
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "Coroutine")), PMCNULL);
    return isa;
}

void
Parrot_Coroutine_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":seg :start_offs :end_offs IHLL_id Fnamespace_name Fnamespace_stash Sname Smethod_name Sns_entry_name Ssubid Ivtable_index Fmulti_signature :n_regs_used Flex_info Fouter_sub Fctx :comp_flags :arg_info Fouter_ctx Iyield :address :caller_seg ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_Coroutine_get_vtable(interp);
        vt->base_type      = enum_class_Coroutine;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "Coroutine");
        vt->provides_str = CONST_STRING_GEN(interp, "invokable");
        vt->isa_hash     = Parrot_Coroutine_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_Coroutine_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_Coroutine;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_Coroutine_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
        }
    } /* pass */
} /* Parrot_Coroutine_class_init */

#line 297 "./src/pmc/coroutine.pmc"


/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
