/* ex: set ro ft=c:
 * !!!!!!!   DO NOT EDIT THIS FILE   !!!!!!!
 *
 * This file is generated automatically from './src/pmc/packfileview.pmc'
 * by tools/build/pmc2c.pl.
 *
 * Any changes made here will be lost!
 *
 */

/* HEADERIZER HFILE: none */
/* HEADERIZER STOP */

#include "parrot/parrot.h"
#include "parrot/extend.h"
#include "parrot/dynext.h"
#include "pmc_fixedintegerarray.h"
#include "pmc_packfileview.h"
#include "pmc_default.h"
#include "packfileview.str"
#include "pmc_continuation.h"
#include "pmc_callcontext.h"
#line 1 "./src/pmc/packfileview.pmc"
/*
Copyright (C) 2011-2012, Parrot Foundation.

=head1 NAME

src/pmc/packfileview.pmc - PackfileView PMC

=head1 DESCRIPTION

This class implements a user-accessible, read-only wrapper for the PackFile*
structure used internally by Parrot. It is essentially an interface for the user
to call Packfile subsystem API calls, and work with the PackFile* structures
output from utilities which generate them.

NOTICE: This PMC should contain very little logic. It should be a thin wrapper
around the public functions in src/packfile/api.c. This PMC should contain
absolutely NO functionality for modifying the packfile. To create a new
packfile or modify an existing one, use the PackFile PMC instead.

=head2 VTABLES

=over 4

=cut

*/

/* HEADERIZER HFILE: none */
/* HEADERIZER BEGIN: static */
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */

static void add_called_tag(PARROT_INTERP,
    ARGMOD(PMC * self),
    ARGIN(STRING * tag))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3)
        FUNC_MODIFIES(* self);

static INTVAL find_called_tag(PARROT_INTERP,
    ARGIN(PMC * self),
    ARGIN(STRING * tag))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2)
        __attribute__nonnull__(3);

PARROT_CAN_RETURN_NULL
static PackFile_ConstTable * get_const_table(PARROT_INTERP,
    ARGIN(PMC * self))
        __attribute__nonnull__(2);

PARROT_CANNOT_RETURN_NULL
static PMC * get_first_sub(PARROT_INTERP, ARGIN(PMC *pfpmc))
        __attribute__nonnull__(1)
        __attribute__nonnull__(2);

#define ASSERT_ARGS_add_called_tag __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(tag))
#define ASSERT_ARGS_find_called_tag __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(self) \
    , PARROT_ASSERT_ARG(tag))
#define ASSERT_ARGS_get_const_table __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(self))
#define ASSERT_ARGS_get_first_sub __attribute__unused__ int _ASSERT_ARGS_CHECK = (\
       PARROT_ASSERT_ARG(interp) \
    , PARROT_ASSERT_ARG(pfpmc))
/* Don't modify between HEADERIZER BEGIN / HEADERIZER END.  Your changes will be lost. */
/* HEADERIZER END: static */

/*

=item C<static PackFile_ConstTable * get_const_table(PARROT_INTERP, PMC * self)>

Get the constant table for the PackFile*. Return NULL if there's a problem.

=cut

*/

PARROT_CAN_RETURN_NULL
static PackFile_ConstTable *
get_const_table(SHIM_INTERP, ARGIN(PMC * self))
{
    ASSERT_ARGS(get_const_table)
    Parrot_PackfileView_attributes * const attrs =
                PARROT_PACKFILEVIEW(self);
    PackFile * const pf = attrs->pf;
    PackFile_ByteCode * bt;
    if (!pf)
        return NULL;
    bt = pf->cur_cs;
    if (!bt)
        return NULL;
    return bt->const_table;
}

/*

=item C<static INTVAL find_called_tag(PARROT_INTERP, PMC * self, STRING * tag)>

Find a called tag in the cache. Return 1 if it exists, 0 otherwise.

=item C<static void add_called_tag(PARROT_INTERP, PMC * self, STRING * tag)>

Add a called tag to the cache, if it doesn't exist already. Do nothing
otherwise.

=cut

*/

static INTVAL
find_called_tag(PARROT_INTERP, ARGIN(PMC * self), ARGIN(STRING * tag))
{
    ASSERT_ARGS(find_called_tag)
    Parrot_PackfileView_attributes * const attrs = PARROT_PACKFILEVIEW(self);
    PMC *  const called_tags = attrs->called_tags;
    if (!PMC_IS_NULL(called_tags)) {
        const INTVAL count = VTABLE_elements(interp, called_tags);
        INTVAL i;
        for (i = 0; i < count; i++) {
            STRING * const str = VTABLE_get_string_keyed_int(interp, called_tags, i);
            if (STRING_equal(interp, str, tag))
                return 1;
        }
    }
    return 0;
}

static void
add_called_tag(PARROT_INTERP, ARGMOD(PMC * self), ARGIN(STRING * tag))
{
    ASSERT_ARGS(add_called_tag)
    const int has_it = find_called_tag(interp, self, tag);
    if (!has_it) {
        Parrot_PackfileView_attributes * const attrs = PARROT_PACKFILEVIEW(self);
        PMC *  called_tags = attrs->called_tags;
        if (PMC_IS_NULL(called_tags)) {
            called_tags = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
            attrs->called_tags = called_tags;
        }
        VTABLE_push_string(interp, called_tags, tag);
    }
}
#line 171 "./src/pmc/packfileview.c"
static  void  Parrot_PackfileView_destroy(PARROT_INTERP, ARGMOD(PMC *_self));
static  INTVAL  Parrot_PackfileView_get_bool(SHIM_INTERP, ARGMOD(PMC *_self));
static  FLOATVAL  Parrot_PackfileView_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  PMC *  Parrot_PackfileView_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  void  * Parrot_PackfileView_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self));
static  STRING *  Parrot_PackfileView_get_string(SHIM_INTERP, ARGMOD(PMC *_self));
static  STRING *  Parrot_PackfileView_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx);
static  void  Parrot_PackfileView_init(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_mark(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_PackfileView_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *path);
static  void Parrot_PackfileView_nci_constant_counts(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_main_sub(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_subs_by_tag(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_single_sub_by_tag(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_subs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_first_sub_in_const_table(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_tags(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_all_tagged_pmcs(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_mark_initialized(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_is_initialized(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_serialized_size(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_serialize(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_deserialize(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_read_from_file(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_write_to_file(PARROT_INTERP, ARGMOD(PMC *_self));
static  void Parrot_PackfileView_nci_get_version(PARROT_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_init_orig(SHIM_INTERP, ARGMOD(PMC *_self));
static  void  Parrot_PackfileView_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr);
static  void  Parrot_PackfileView_set_string_native_orig(SHIM_INTERP, ARGMOD(PMC *_self), STRING *path);
void    Parrot_PackfileView_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_PackfileView_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_PackfileView_get_vtable(PARROT_INTERP);
void    Parrot_PackfileView_ro_class_init(PARROT_INTERP, int, int);
PARROT_EXPORT VTABLE* Parrot_PackfileView_ro_update_vtable(ARGMOD(VTABLE*));
PARROT_EXPORT VTABLE* Parrot_PackfileView_ro_get_vtable(PARROT_INTERP);
static  void 
Parrot_PackfileView_destroy(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 191 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_pf_destroy(interp, attrs->pf);
#line 217 "./src/pmc/packfileview.c"
}
static  INTVAL 
Parrot_PackfileView_get_bool(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 238 "./src/pmc/packfileview.pmc"
    return (PARROT_PACKFILEVIEW(_self)->pf != NULL);
#line 224 "./src/pmc/packfileview.c"
}
static  FLOATVAL 
Parrot_PackfileView_get_number_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 305 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return 0.0;
    if (idx < 0 || idx >= ct->num.const_count) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "PMC constant index out of bounds");
    }
    return ct->num.constants[idx];
#line 239 "./src/pmc/packfileview.c"
}
static  PMC * 
Parrot_PackfileView_get_pmc_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 283 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return PMCNULL;
    if (idx < 0 || idx >= ct->pmc.const_count) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "PMC constant index out of bounds");
    }
    return ct->pmc.constants[idx];
#line 254 "./src/pmc/packfileview.c"
}
static  void  *
Parrot_PackfileView_get_pointer(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 233 "./src/pmc/packfileview.pmc"
    return PARROT_PACKFILEVIEW(_self)->pf;
#line 261 "./src/pmc/packfileview.c"
}
static  STRING * 
Parrot_PackfileView_get_string(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 258 "./src/pmc/packfileview.pmc"
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    return attrs->path ? attrs->path : STRINGNULL;
#line 270 "./src/pmc/packfileview.c"
}
static  STRING * 
Parrot_PackfileView_get_string_keyed_int(PARROT_INTERP, ARGMOD(PMC *_self), INTVAL idx)
{
#line 294 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        return STRINGNULL;
    if (idx < 0 || idx >= ct->str.const_count) {
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_OUT_OF_BOUNDS,
            "STRING constant index out of bounds");
    }
    return ct->str.constants[idx];
#line 285 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_init(PARROT_INTERP, ARGMOD(PMC *_self))
{
Parrot_PackfileView_init_orig(interp, _self);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_PackfileView_mark(PARROT_INTERP, ARGMOD(PMC *_self))
{
#line 172 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_pf_mark_packfile(interp, attrs->pf);
    if (!STRING_IS_NULL(attrs->path))
        Parrot_gc_mark_STRING_alive(interp, attrs->path);
    if (!PMC_IS_NULL(attrs->called_tags))
        Parrot_gc_mark_PMC_alive(interp, attrs->called_tags);
#line 306 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_set_pointer(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
Parrot_PackfileView_set_pointer_orig(interp, _self, ptr);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void 
Parrot_PackfileView_set_string_native(PARROT_INTERP, ARGMOD(PMC *_self), STRING *path)
{
Parrot_PackfileView_set_string_native_orig(interp, _self, path);
PARROT_GC_WRITE_BARRIER(interp, _self);
}
static  void
Parrot_PackfileView_nci_constant_counts(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 333 "./src/pmc/packfileview.pmc"

    PackFile_ConstTable * const ct = get_const_table(interp, _self);
    if (!ct)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "NULL or Malformed Packfile");
    else {
        PMC * const counts = Parrot_pmc_new(interp, enum_class_FixedIntegerArray);
        VTABLE_set_integer_native(interp, counts, 3);
        VTABLE_set_integer_keyed_int(interp, counts, 0, ct->num.const_count);
        VTABLE_set_integer_keyed_int(interp, counts, 1, ct->str.const_count);
        VTABLE_set_integer_keyed_int(interp, counts, 2, ct->pmc.const_count);
        #line 343 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *counts */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)counts);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *counts */
    }
#line 344 "./src/pmc/packfileview.pmc"

    }
#line 355 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_main_sub(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 396 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 380 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *PMCNULL */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)PMCNULL);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *PMCNULL */
    }
#line 400 "./src/pmc/packfileview.pmc"

    else {
        PMC * const main_sub = Parrot_pf_get_packfile_main_sub(interp, _self);
        #line 393 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *main_sub */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)main_sub);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *main_sub */
    }
#line 403 "./src/pmc/packfileview.pmc"

    }
#line 405 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_subs_by_tag(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* flag;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &flag);
    { /* BEGIN PMETHOD BODY */
#line 407 "./src/pmc/packfileview.pmc"

    PMC * const subs = Parrot_pf_subs_by_tag(interp, _self, flag);
    #line 429 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *subs */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)subs);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *subs */
    }
#line 409 "./src/pmc/packfileview.pmc"

#line 440 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_single_sub_by_tag(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* flag;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &flag);
    { /* BEGIN PMETHOD BODY */
#line 412 "./src/pmc/packfileview.pmc"

    PMC * const sub = Parrot_pf_single_sub_by_tag(interp, _self, flag);
    #line 464 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *sub */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)sub);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *sub */
    }
#line 414 "./src/pmc/packfileview.pmc"

#line 475 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_subs(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 417 "./src/pmc/packfileview.pmc"

    PMC * const array = Parrot_pf_all_subs(interp, _self);
    #line 498 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *array */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)array);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *array */
    }
#line 419 "./src/pmc/packfileview.pmc"

#line 509 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_first_sub_in_const_table(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 422 "./src/pmc/packfileview.pmc"

    PMC * const sub = get_first_sub(interp, _self);
    #line 532 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *sub */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)sub);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *sub */
    }
#line 424 "./src/pmc/packfileview.pmc"

#line 543 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_tags(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 427 "./src/pmc/packfileview.pmc"

    PMC * const array = Parrot_pf_all_tags_list(interp, _self);
    #line 566 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *array */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)array);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *array */
    }
#line 429 "./src/pmc/packfileview.pmc"

#line 577 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_all_tagged_pmcs(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 432 "./src/pmc/packfileview.pmc"

    PMC * const hash = Parrot_pf_all_tagged_pmcs(interp, _self);
    #line 600 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN PMC *hash */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "P", (PMC*)hash);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN PMC *hash */
    }
#line 434 "./src/pmc/packfileview.pmc"

#line 611 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_mark_initialized(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* tag;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &tag);
    { /* BEGIN PMETHOD BODY */
#line 437 "./src/pmc/packfileview.pmc"

    add_called_tag(interp, _self, tag);
#line 635 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_is_initialized(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* tag;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &tag);
    { /* BEGIN PMETHOD BODY */
#line 441 "./src/pmc/packfileview.pmc"

    const INTVAL has_it = find_called_tag(interp, _self, tag);
    #line 659 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN INTVAL has_it */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)has_it);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL has_it */
    }
#line 443 "./src/pmc/packfileview.pmc"

#line 670 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_serialized_size(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 465 "./src/pmc/packfileview.pmc"

    INTVAL size;
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 696 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN INTVAL 0 */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)0);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL 0 */
    }
#line 470 "./src/pmc/packfileview.pmc"

    size = Parrot_pf_serialized_size(interp, attrs->pf);
    #line 708 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN INTVAL size */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "I", (INTVAL)size);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN INTVAL size */
    }
#line 472 "./src/pmc/packfileview.pmc"

#line 719 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_serialize(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 475 "./src/pmc/packfileview.pmc"

    STRING *str;
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf == NULL)
        #line 745 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN STRING *STRINGNULL */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)STRINGNULL);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *STRINGNULL */
    }
#line 480 "./src/pmc/packfileview.pmc"

    str = Parrot_pf_serialize(interp, attrs->pf);
    #line 757 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN STRING *str */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)str);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING *str */
    }
#line 482 "./src/pmc/packfileview.pmc"

#line 768 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_deserialize(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* pbc;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &pbc);
    { /* BEGIN PMETHOD BODY */
#line 485 "./src/pmc/packfileview.pmc"

    PackFile * const pf = Parrot_pf_deserialize(interp, pbc);
    VTABLE_set_pointer(interp, _self, pf);
#line 793 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_read_from_file(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* filename;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &filename);
    { /* BEGIN PMETHOD BODY */
#line 506 "./src/pmc/packfileview.pmc"

    PackFile * const pf = Parrot_pf_read_pbc_file(interp, filename);
    VTABLE_set_pointer(interp, _self, pf);
    pf->view = _self;
    VTABLE_set_string_native(interp, _self, filename);
#line 820 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_write_to_file(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */
STRING* filename;

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "PiS",
            &_self, &filename);
    { /* BEGIN PMETHOD BODY */
#line 513 "./src/pmc/packfileview.pmc"

    Parrot_pf_write_pbc_file(interp, _self, filename);
#line 844 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void
Parrot_PackfileView_nci_get_version(PARROT_INTERP, ARGMOD(PMC *_self))
{
    PMC * const _ctx         = CURRENT_CONTEXT(interp);
    PMC * const _call_object = Parrot_pcc_get_signature(interp, _ctx);

    { /* BEGIN PARMS SCOPE */

        Parrot_pcc_fill_params_from_c_args(interp, _call_object, "Pi",
            &_self);
    { /* BEGIN PMETHOD BODY */
#line 527 "./src/pmc/packfileview.pmc"

    STRING * const version = Parrot_pf_get_version_string(interp, _self);
    #line 867 "./src/pmc/packfileview.c"
    {
    /*BEGIN RETURN STRING * version */
    Parrot_pcc_set_call_from_c_args(interp, _call_object,
        "S", (STRING*)version);
    PARROT_GC_WRITE_BARRIER(interp, _self);
    return;
    /*END RETURN STRING * version */
    }
#line 529 "./src/pmc/packfileview.pmc"

#line 878 "./src/pmc/packfileview.c"

    } /* END PMETHOD BODY */

    PARROT_GC_WRITE_BARRIER(interp, _self);

    } /* END PARAMS SCOPE */
    return;
}
static  void 
Parrot_PackfileView_init_orig(SHIM_INTERP, ARGMOD(PMC *_self))
{
#line 183 "./src/pmc/packfileview.pmc"
    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    attrs->pf = NULL;
    PObj_custom_mark_destroy_SETALL(_self);
#line 895 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_set_pointer_orig(PARROT_INTERP, ARGMOD(PMC *_self), void *ptr)
{
#line 222 "./src/pmc/packfileview.pmc"

    Parrot_PackfileView_attributes * const attrs =
            PARROT_PACKFILEVIEW(_self);
    if (attrs->pf != NULL)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_INVALID_OPERATION,
            "Cannot overwrite existing pointer in PackfileView");
    attrs->pf = (PackFile*)ptr;
    if (ptr != NULL)
        PARROT_GC_WRITE_BARRIER(interp, _self);
#line 910 "./src/pmc/packfileview.c"
}
static  void 
Parrot_PackfileView_set_string_native_orig(SHIM_INTERP, ARGMOD(PMC *_self), STRING *path)
{
#line 253 "./src/pmc/packfileview.pmc"
    PARROT_PACKFILEVIEW(_self)->path = path;
#line 917 "./src/pmc/packfileview.c"
}
#include "pmc_default.h"

PARROT_EXPORT
VTABLE *Parrot_PackfileView_update_vtable(VTABLE *vt) {
    vt->destroy = Parrot_PackfileView_destroy;
    vt->get_bool = Parrot_PackfileView_get_bool;
    vt->get_number_keyed_int = Parrot_PackfileView_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_PackfileView_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileView_get_pointer;
    vt->get_string = Parrot_PackfileView_get_string;
    vt->get_string_keyed_int = Parrot_PackfileView_get_string_keyed_int;
    vt->init = Parrot_PackfileView_init;
    vt->mark = Parrot_PackfileView_mark;
    vt->set_pointer = Parrot_PackfileView_set_pointer;
    vt->set_string_native = Parrot_PackfileView_set_string_native;
    vt->attr_size = sizeof(Parrot_PackfileView_attributes);

    return vt;
}


PARROT_EXPORT
VTABLE *Parrot_PackfileView_ro_update_vtable(ARGMOD(VTABLE *vt)) {
    vt->destroy = Parrot_PackfileView_destroy;
    vt->get_bool = Parrot_PackfileView_get_bool;
    vt->get_number_keyed_int = Parrot_PackfileView_get_number_keyed_int;
    vt->get_pmc_keyed_int = Parrot_PackfileView_get_pmc_keyed_int;
    vt->get_pointer = Parrot_PackfileView_get_pointer;
    vt->get_string = Parrot_PackfileView_get_string;
    vt->get_string_keyed_int = Parrot_PackfileView_get_string_keyed_int;
    vt->mark = Parrot_PackfileView_mark;
    vt->attr_size = sizeof(Parrot_PackfileView_attributes);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileView_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_get_vtable(interp);
    Parrot_PackfileView_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
VTABLE* Parrot_PackfileView_ro_get_vtable(PARROT_INTERP) {
    VTABLE *vt;
    vt = Parrot_default_ro_get_vtable(interp);
    Parrot_PackfileView_ro_update_vtable(vt);

    return vt;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
PMC* Parrot_PackfileView_get_mro(PARROT_INTERP, ARGMOD(PMC* mro)) {
    if (PMC_IS_NULL(mro)) {
        mro = Parrot_pmc_new(interp, enum_class_ResizableStringArray);
    }

    VTABLE_unshift_string(interp, mro, CONST_STRING_GEN(interp, "PackfileView"));
    return mro;
}

PARROT_EXPORT
PARROT_CANNOT_RETURN_NULL
PARROT_WARN_UNUSED_RESULT
Hash* Parrot_PackfileView_get_isa(PARROT_INTERP, ARGIN_NULLOK(Hash* isa)) {
    if (isa == NULL) {
        isa = Parrot_hash_new(interp);
    }
    Parrot_hash_put(interp, isa, (void *)(CONST_STRING_GEN(interp, "PackfileView")), PMCNULL);
    return isa;
}

void
Parrot_PackfileView_class_init(PARROT_INTERP, int entry, int pass)
{
    static const char attr_defs [] =
        ":pf Spath Fcalled_tags ";
    if (pass == 0) {
        VTABLE * const vt  = Parrot_PackfileView_get_vtable(interp);
        vt->base_type      = enum_class_PackfileView;
        vt->flags          = 0|VTABLE_HAS_READONLY_FLAG;
        vt->attribute_defs = attr_defs;
        interp->vtables[entry] = vt;

        vt->whoami       = CONST_STRING_GEN(interp, "PackfileView");
        vt->provides_str = CONST_STRING_GEN(interp, "scalar");
        vt->isa_hash     = Parrot_PackfileView_get_isa(interp, NULL);
        {
            VTABLE * const vt_ro         = Parrot_PackfileView_ro_get_vtable(interp);
            vt_ro->base_type           = enum_class_PackfileView;
            vt_ro->flags               = 0|VTABLE_IS_READONLY_FLAG;

            vt_ro->attribute_defs      = attr_defs;

            vt_ro->base_type           = entry;
            vt_ro->whoami              = vt->whoami;
            vt_ro->provides_str        = vt->provides_str;
            vt->ro_variant_vtable     = vt_ro;
            vt_ro->ro_variant_vtable = vt;
            vt_ro->isa_hash            = vt->isa_hash;
        }

    }
    else { /* pass */
        {
            VTABLE * const vt  = interp->vtables[entry];

            vt->mro = Parrot_PackfileView_get_mro(interp, PMCNULL);

            if (vt->ro_variant_vtable)
                vt->ro_variant_vtable->mro = vt->mro;
        }

        /* set up MRO and _namespace */
        Parrot_pmc_create_mro(interp, entry);
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "constant_counts");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_constant_counts),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "main_sub");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_main_sub),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "subs_by_tag");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_subs_by_tag),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "single_sub_by_tag");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_single_sub_by_tag),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_subs");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_subs),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "first_sub_in_const_table");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_first_sub_in_const_table),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_tags");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_tags),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "all_tagged_pmcs");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_all_tagged_pmcs),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "mark_initialized");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_mark_initialized),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "is_initialized");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_is_initialized),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "serialized_size");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_serialized_size),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "serialize");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_serialize),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "deserialize");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_deserialize),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "read_from_file");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_read_from_file),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "write_to_file");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_write_to_file),
                method_name, signature);
        }
        {
            STRING * const method_name = CONST_STRING_GEN(interp, "get_version");
            STRING * const signature   = CONST_STRING_GEN(interp, "->");
            Parrot_interp_register_native_pcc_method_in_ns(interp, entry,
                F2DPTR(Parrot_PackfileView_nci_get_version),
                method_name, signature);
        }
        {
        }
    } /* pass */
} /* Parrot_PackfileView_class_init */

#line 530 "./src/pmc/packfileview.pmc"


/*

=item C<static PMC * get_first_sub(PARROT_INTERP, PMC *pfpmc)>

Returns the first Sub constant from the constant table.

=cut

*/

PARROT_CANNOT_RETURN_NULL
static PMC *
get_first_sub(PARROT_INTERP, ARGIN(PMC *pfpmc))
{
    ASSERT_ARGS(get_first_sub)
    PackFile * const pf = (PackFile*)VTABLE_get_pointer(interp, pfpmc);
    if (!pf || !pf->cur_cs || !pf->cur_cs->const_table)
        Parrot_ex_throw_from_c_args(interp, NULL, EXCEPTION_UNEXPECTED_NULL,
            "NULL or invalid packfile");

    {
        PackFile_ConstTable * const ct = pf->cur_cs->const_table;
        INTVAL i;
        STRING * const SUB = CONST_STRING(interp, "Sub");
        for (i = 0; i < ct->pmc.const_count; ++i) {
            PMC * const x = ct->pmc.constants[i];
            if (VTABLE_isa(interp, x, SUB))
                return x;
        }
        return PMCNULL;
    }
}

/*

=back

=cut

*/

/*
 * Local variables:
 *   c-file-style: "parrot"
 * End:
 * vim: expandtab shiftwidth=4 cinoptions='\:2=2' :
 */
